﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace henchman
{


    public partial class AltPaste : Form
    {

        KeyboardHook hook = new KeyboardHook();

        //Import the SetForeground API to activate it
        [DllImport("User32.dll", EntryPoint = "SetForegroundWindow")]
        private static extern IntPtr SetForegroundWindowNative(IntPtr hWnd);

        [DllImport("user32.dll")]
        private static extern IntPtr GetForegroundWindow();

        bool ConcurrencyFlagWeAreBusyNow = false;

        // so we can prevent more than one from happening...
        MessageForm msgform;

        public AltPaste()
        {
            InitializeComponent();

            /*
            if (textBox1.BorderStyle == BorderStyle.None)
            {
                textBox1.BorderStyle = BorderStyle.FixedSingle;
                var heightWithBorder = textBox1.ClientRectangle.Height;
                textBox1.BorderStyle = BorderStyle.None;
                textBox1.AutoSize = false;
                textBox1.Height = heightWithBorder;
            }
            */

            // register the event that is fired after the key press.
            hook.KeyPressed += new EventHandler<KeyPressedEventArgs>(hook_KeyPressed);
            // @@ todo - make the registered hot key read from config so it can be changed
            //hook.RegisterHotKey(henchman.ModifierKeys.Control, Keys.Oemtilde);
            hook.RegisterHotKey(henchman.ModifierKeys.Alt, Keys.Insert);

            this.WindowState = FormWindowState.Minimized;
            this.ShowInTaskbar = false;

            // well, fuck including the Icon twice, it doubles the size of the application!
            this.Icon = Icon.ExtractAssociatedIcon(Application.ExecutablePath);
            notifyIcon1.Icon = this.Icon;


            PopUpMessageForm("AltPaste is now running in the system tray.\nAlt-Insert to Paste, right click the tray icon to exit.");

        }

        void hook_KeyPressed(object sender, KeyPressedEventArgs e)
        {

            if (ConcurrencyFlagWeAreBusyNow)
            {
                // somehow we're in a race condition, so we abort and do not a goddamn thing
                return;
            }

            ConcurrencyFlagWeAreBusyNow = true;

            if (Clipboard.ContainsText())
            {
                PopUpMessageForm("Release ALT to paste.");
                tmrIsAltGoneYet.Enabled = true;
            }
            else
            {
                PopUpMessageForm("Clipboard does not contain text.");
            }

        }

        void PopUpMessageForm(string msg)
        {
            if (msgform != null)
            {
                msgform.Dispose();
            }

            
            msgform = new MessageForm(msg);

            msgform.Show();
        }

      


        /*
        <mdsn>
        The plus sign (+), caret (^), percent sign (%), tilde (~), and parentheses
        () have special meanings to SendKeys. To specify one of these characters,
        enclose it within braces ({}). For example, to specify the plus sign, use
        "{+}". To specify brace characters, use "{{}" and "{}}". Brackets ([ ]) have no special meaning to SendKeys, but you must enclose them in braces.
        </msdn>
         */
        private string EscapeForSendKeys(string s)
        {
            string buf = "";

            foreach (char c in s)
            {
                if ("+^%~(){}[]".Contains(c))
                {
                    buf = buf + "{" + c + "}";
                }
                else
                {
                    buf += c;
                }
            }

            return buf;

        }
        

        

        private void notifyIcon1_Click(object sender, EventArgs e)
        {
            //this.Show();
            //this.WindowState = FormWindowState.Normal;
            //ShowInTaskbar = true;
            //this.BringToFront();
        }

        private void tmrIsAltGoneYet_Tick(object sender, EventArgs e)
        {
            if (ModifierKeys == Keys.Alt)
            {
                tmrIsAltGoneYet.Enabled = true;
                return;
            }
            else
            {
                tmrIsAltGoneYet.Enabled = false;
            }



            if (Clipboard.ContainsText())
            {
                PopUpMessageForm("Pasting...");

                // obnoxious timer here because sendkeys 
                tmrDoThePaste.Enabled = true;
                
                
            }
            else
            {
                PopUpMessageForm("Clipboard does not contain text.");
            }

        }

        private void previewToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
            notifyIcon1.Dispose();

            Application.Exit();
        }

        private void Henchman_FormClosing(object sender, FormClosingEventArgs e)
        {
            
            notifyIcon1.Dispose();
        }

        private void tmrDoThePaste_Tick(object sender, EventArgs e)

        {
            tmrDoThePaste.Enabled = false;
            SendKeys.Send(EscapeForSendKeys(Clipboard.GetText()));
            PopUpMessageForm("Paste Complete.");

            // and... we're clear.  
            ConcurrencyFlagWeAreBusyNow = false;
        }

        private void websiteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("http://www.elifulkerson.com");
        }

    }
}
